/* $Id$ */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>
#include <syslog.h>

/*
  usage: mgfixdate [-f file] [-n]

Mgfixdate PocketBSDդľΥץǤ

mgfixdateϵưˡ
ꤵ줿ե (ǥեȤǤ /etc/mglastdate) 
դ˸ߤΥƥդꤷޤ
˥ǡץȤƾ󤷡
֤Ȥ˥ե򹹿ߤդݤĤ褦
ޤ

  -f file  /etc/mglastdateǤϤʤꤵ줿ե
  	դꤷޤ
  
  -n ǡȤƾ󤷤ޤ󡣸߻Τߤ
     Ԥޤ
*/

#define DATEFILE "/etc/mglastdate"
#define SECADAY (60 * 60 * 24)

char *datefile = DATEFILE;
int interval = 2 * 60 * 60;

void
usage()
{
  fputs("usage: mgfixdate [-f file] [-i interval] [-n]\n", stderr);
  exit(1);
}

int
fixdate()
{
  struct stat stats;
  struct timeval now;
  struct tm *nowtm, filetm;

  if (stat(datefile, &stats)) {
    perror(datefile);
    return -1;
  }

  gettimeofday(&now, NULL);

  if (now.tv_sec >= stats.st_mtime) return 0;

  memcpy(&filetm, localtime(&stats.st_mtime), sizeof filetm);
  nowtm = localtime(&now.tv_sec);
  nowtm->tm_year = filetm.tm_year;
  nowtm->tm_mon = filetm.tm_mon;
  nowtm->tm_mday = filetm.tm_mday;
  now.tv_sec = mktime(nowtm);
  settimeofday(&now, NULL);
  syslog(LOG_NOTICE, "mgfixdate: fix date as %04d/%02d/%02d %02d:%02d:%02d\n",
	 nowtm->tm_year + 1900, nowtm->tm_mon + 1, nowtm->tm_mday,
	 nowtm->tm_hour, nowtm->tm_min, nowtm->tm_sec);
  return 0;
}

int
touch()
{
  struct timeval now[2];
  gettimeofday(now, NULL);
  now[1] = now[0];
  return utimes(datefile, now);
}

int
main(int argc, char *argv[])
{
  int nodaemon = 0;
  int c;

  while ((c = getopt(argc, argv, "nf:i:")) != EOF) {
    switch (c) {
    case 'n':
      nodaemon = 1; break;
    case 'f':
      datefile = optarg; break;
    case 'i':
      interval = strtol(optarg, NULL, 10); break;
    default:
      usage();
    }
  }
  fixdate();

  if (nodaemon) return 0;

  if (access(datefile, W_OK) < 0) {
    int fd;
    fd = open(datefile, O_CREAT, 0666);
    if (fd < 0) {
      perror(datefile); return 1;
    }
    close(fd);
  }

  daemon(0, 0);

  while (1) {
    touch();
    sleep(interval);
  }

  return 0;
}

